AC_DEFUN([AC_CHECK_LAME],
[
AC_ARG_WITH(lame-prefix,[  --with-lame-prefix=PFX   Prefix where libmp3lame is installed (optional)],
             lame_prefix="$withval", lame_prefix="")
AC_ARG_ENABLE(lametest, [  --disable-lametest       Do not try to compile and run the libmp3lame test program],
 		    , enable_lametest=yes)

  LAME_LIBS="-lmp3lame"
  LAME_CFLAGS=""
  if test -n "$lame_prefix"; then
    export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$lame_prefix/lib"
    LAME_CFLAGS="-I$LAME_prefix/include"
    LAME_LIBS="-L$lame_prefix/lib $LAME_LIBS"
  fi

  min_lame_version=ifelse([$1], , 3.89, $1)
  AC_MSG_CHECKING([for libmp3lame])
  if test -n "$enable_lametest"; then
    ac_save_CFLAGS="$CFLAGS"
    ac_save_LIBS="$LIBS"
    CFLAGS="$CFLAGS $LAME_CFLAGS"
    LIBS="$LAME_LIBS $LIBS"
dnl
dnl Now check if the installed lamelib is sufficiently new.
dnl
dnl     AC_TRY_RUN([
dnl #include <lame/lame.h>
dnl #include <stdio.h>
dnl #include <string.h>
dnl #include <stdlib.h>
dnl
dnl int
dnl main ()
dnl {
dnl   int major, minor;
dnl   lame_version_t *lame_version;
dnl   char *tmp_version;
dnl
dnl   tmp_version = strdup("$min_lame_version");
dnl   if (sscanf(tmp_version, "%d.%d", &major, &minor) != 2) {
dnl      printf("%s, bad version string\n", "$min_lame_version");
dnl      exit(1);
dnl    }
dnl
dnl    get_lame_version_numerical ( lame_version );
dnl
dnl    if ((lame_version->major >= major) && (lame_version->minor >= minor))
dnl      {
dnl        return 0;
dnl      }
dnl    else
dnl      {
dnl        printf("\n*** An old version of libmp3lame (%s) was found.\n", get_lame_version());
dnl        printf("*** This program requires at least version %s. The latest version of\n", "$min_lame_version");
dnl        printf("*** libmp3lame is always available from http://www.mp3dev.org/\n"); }
dnl    return 1;
dnl }
dnl ]
dnl , dnl do nothing if TRY_RUN worked
dnl , dnl define lame_failure if TRY_RUN failed
dnl   lame_failure=yes
dnl ,
dnl [
dnl echo $ac_n "cross compiling; cannot test version... $ac_c"
dnl           AC_TRY_LINK([
dnl #include <stdio.h>
dnl #include <stdlib.h>
dnl #include <lame/lame.h>
dnl ],      [ return get_lame_version; ],
dnl         [ ],
dnl         [ lame_failure=yes ])
dnl ]
dnl )

    CFLAGS="$ac_save_CFLAGS"
    LIBS="$ac_save_LIBS"
  fi

  dnl
  dnl See is the program failed
  dnl
  if test "$lame_failure" = "yes"; then
     AC_MSG_RESULT(no)
     CFLAGS="$ac_save_CFLAGS"
     LIBS="$ac_save_LIBS"
     LAME_CFLAGS=""
     LAME_LIBS=""
     ifelse([$3], , :, [$3])
  else
     AC_MSG_RESULT(yes)
     ifelse([$2], , :, [$2])
  fi

  AC_SUBST(LAME_CFLAGS)
  AC_SUBST(LAME_LIBS)
])
